=== debian/changelog ===
mlton (20100608-5.1ubuntu1) yakkety; urgency=medium

  * Build with -fPIC on amd64 since binaries there are now PIE; but also
    pass -no-pie to the linker for cases where not all objects we're linking
    are position-independent.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Jul 2016 23:23:57 -0700

mlton (20100608-5.1) unstable; urgency=low

  * Non-Maintainer Upload
  * Apply upstream patch to avoid __gmp_const breakage
    (Closes: 707410)
  * Apply patch from Matthias Klose to allow building on more target
    triplets on i386, not just i486-linux-gnu (Closes: 640137)

 -- Florian Weimer <fw@deneb.enyo.de>  Sat, 19 Oct 2013 19:39:58 +0200

mlton (20100608-5) unstable; urgency=low

  * Newest gcc and binutils fix mips[el] jump problem
   * Uploaded mips[el] bootstrap packages as 20100608-4
   * Build-Depend on newest gcc and binutils
   * Removed explicit-relocs patch
  * Include a diffs to current release head
   * Necessary for 8-bit aligned MIPS read/writes
   * Increase heap-size for mips post-alignment
  * Building armel on debian buildd instead of qemu
   * Heap-size 1.2g on 1.5g machines
  * Added armhf port

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Tue, 19 Jul 2011 12:29:52 +0200

mlton (20100608-4) unstable; urgency=low

  * Add missing install file for sparc runtime
  * Make the self target symlink relative
  * Added Replaces and Breaks the old version for smooth upgrades
  * Previous build needed manual uploads, so buildd rebuild needed
  * Still needing bootstrap:
   * mips(el) gcc bug still unresolved and no-explicit-relocs fails too

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Fri, 01 Apr 2011 22:57:25 +0200

mlton (20100608-3) unstable; urgency=low

  * Include all bugfixes since 20100608 release
  * Depend on libgmp-dev (closes: #618268)
  * Split package into compiler, runtime, basis, tools, and doc
   * Use multiarch to support cross-compiling
   * Eliminates the need for a mlton-cross package
  * Updated standards version (no changes needed)

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 20 Mar 2011 14:05:32 +0100

mlton (20100608-2) unstable; urgency=low

  * Added a new '-mno-explicit-relocs' mips work-around.
   * Bug filed with gcc upstream (#44537)

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Mon, 14 Jun 2010 18:28:58 +0200

mlton (20100608-1) unstable; urgency=low

  * New upstream release
  * Removed the mips -fPIC work-around
   * Filing a new gcc bug report upstream

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Fri, 11 Jun 2010 16:11:59 +0200

mlton (20100504~svn-r7459) unstable; urgency=low

  * New snapshot from svn/HEAD
   * Includes fixes for PIC codegen on x86
   * Better handling of memory exhaustion
   * Fix aliasing problem with newest gcc
  * Switch to using quilt source format

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Tue, 04 May 2010 19:26:59 +0200

mlton (20100206~svn-r7414) unstable; urgency=low

  * s390 and hurd need fixed-heap to stop thrashing on resize
  * qemu'd armel needs max-heap to work-around mmap emulation problems
   => heap-size must choose {fixed/max}-heap

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Mon, 08 Feb 2010 20:22:20 +0100

mlton (20100206~svn-r7412) unstable; urgency=low

  * Restored -fPIC work-around and reopened #552314.
  * Got a qemu-linux-user with 1G of RAM to work => added armel target.

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sat, 06 Feb 2010 11:16:31 +0100

mlton (20100205~svn-r7410) unstable; urgency=low

  * New snapshot from svn/HEAD
   * Split targets into sub-folder
   * makes cross-compiler packages possible
  * Add a debian/watch file for lintian
  * Correct spelling errors in the manual page
  * Updated to policy 3.8.4.0 (no changes)
  * Removed -fPIC work-around for mips (closes: #552314)

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Fri, 05 Feb 2010 17:13:06 +0100

mlton (20091212~svn-r7383) unstable; urgency=low

  * New snapshot from svn/HEAD
   * Works around incompatible change to 'patch' (closes: #560623)
  * Use a version number that reflects the snapshot nature (closes: #559014)
   * Both upstream and debian packaging live in the same svn repository
    * Prune the packaging folder from snapshots as well as releases
   * For release versions use 20YYMMDD-rXXX, where
    * 20YYMMDD is the name of the release soruce tarball
    * XXX is the svn version of the packaging used
   * For snapshots use 20YYMMDD~svn-rXXX, where
    * 20YYMMDD is the date the snapshot was made
    * XXX is the svn version of the packaging and source used

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sat, 12 Dec 2009 02:37:12 +0100

mlton (20091107) unstable; urgency=low

  * gcc-4.4 miscompiles more than just fpclassify. It is unusable.
  * gcc-4.1 ICEs so also not an option.
  * => use gcc-4.3, despite an off-by-one bug in mips branch generation
  * Using -fPIC to compile changes the assembler enough to get past #552341

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sat, 07 Nov 2009 17:26:11 +0100

mlton (20091104) unstable; urgency=low

  * Two more regressions disabled on hurd (thread2 and world5)
  * Switch mips back to gcc-4.4
   * Found the cause of the segfault: fpclassify is broken on mips
   * Disable its on linux/mips and use the MLton IEEE work-around code

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Wed, 04 Nov 2009 12:04:36 +0100

mlton (20091101) unstable; urgency=low

  * The mips saga continues
   * gcc-4.4 miscompiles code
   * gcc-4.3 outputs bad branch statements
   * => gcc-4.1 might work!
  * Don't override gcc version on any architecture but mips[el]
  * Change dependencies to require gcc-4.1 only on mips[el]

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 01 Nov 2009 18:38:37 +0100

mlton (20091029) unstable; urgency=low

  * Bump the heap-size up a bit to 800m (850m for align8) -> fixes s390.

