=== debian/control ===
Source: mlton
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Wesley W. Terpstra (Debian) <terpstra@debian.org>
Build-Depends: mlton (>= 20070826), libgmp-dev, htmldoc, texlive-latex-base, procps, debhelper (>= 7.0.0), cdbs (>= 0.4.52), quilt, binutils (>= 2.21.51.201104) [mips mipsel], gcc (>= 4:4.6.0-5) [mips mipsel]
Standards-Version: 3.9.1

Package: mlton
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-compiler (>= ${source:Version}), mlton-compiler (<< ${source:Version}.1~), mlton-tools (>= ${source:Version}), mlton-tools (<< ${source:Version}.1~), mlton-doc (= ${source:Version})
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This metapackage depends on all MLton packages.

Package: mlton-basis
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - basis library
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes the cross-platform basis.

Package: mlton-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - documentation
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes non-man-page documentation.

Package: mlton-compiler
Architecture: alpha amd64 armel armhf hppa hurd-i386 i386 ia64 kfreebsd-i386 kfreebsd-amd64 mips mipsel powerpc s390 sparc
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, gcc, libc6-dev, libgmp-dev, mlton-basis (= ${source:Version}), mlton-runtime-native (= ${binary:Version}) | mlton-runtime
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - compiler
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes the compiler itself.

Package: mlton-tools
Architecture: alpha amd64 armel armhf hppa hurd-i386 i386 ia64 kfreebsd-i386 kfreebsd-amd64 mips mipsel powerpc s390 sparc
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - tools
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes tools which autogenerate SML.

Package: mlton-runtime-native
Architecture: alpha amd64 armel armhf hppa hurd-i386 i386 ia64 kfreebsd-i386 kfreebsd-amd64 mips mipsel powerpc s390 sparc
Depends: ${misc:Depends}, mlton-runtime-alpha-linux-gnu (= ${binary:Version}) [alpha] | mlton-runtime-x86-64-linux-gnu (= ${binary:Version}) [amd64] | mlton-runtime-arm-linux-gnueabi (= ${binary:Version}) [armel] | mlton-runtime-arm-linux-gnueabihf (= ${binary:Version}) [armhf] | mlton-runtime-hppa-linux-gnu (= ${binary:Version}) [hppa] | mlton-runtime-i486-gnu (= ${binary:Version}) [hurd-i386] | mlton-runtime-i486-linux-gnu (= ${binary:Version}) [i386] | mlton-runtime-ia64-linux-gnu (= ${binary:Version}) [ia64] | mlton-runtime-i486-kfreebsd-gnu (= ${binary:Version}) [kfreebsd-i386] | mlton-runtime-x86-64-kfreebsd-gnu (= ${binary:Version}) [kfreebsd-amd64] | mlton-runtime-mips-linux-gnu (= ${binary:Version}) [mips] | mlton-runtime-mipsel-linux-gnu (= ${binary:Version}) [mipsel] | mlton-runtime-powerpc-linux-gnu (= ${binary:Version}) [powerpc] | mlton-runtime-s390-linux-gnu (= ${binary:Version}) [s390] | mlton-runtime-sparc-linux-gnu (= ${binary:Version}) [sparc]
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - native runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This metapackage depends on native target libraries.

Package: mlton-runtime-alpha-linux-gnu
Architecture: alpha
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - alpha runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides alpha target libraries.

Package: mlton-runtime-x86-64-linux-gnu
Architecture: amd64
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - amd64 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides x86-64 target libraries.

Package: mlton-runtime-arm-linux-gnueabi
Architecture: armel
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - armel runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides arm target libraries.

Package: mlton-runtime-arm-linux-gnueabihf
Architecture: armhf
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - armhf runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides armhf target libraries.

Package: mlton-runtime-hppa-linux-gnu
Architecture: hppa
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - hppa runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides hppa target libraries.

Package: mlton-runtime-i486-gnu
Architecture: hurd-i386
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - hurd-i386 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides hurd i486 target libraries.

Package: mlton-runtime-i486-linux-gnu
Architecture: i386
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - i386 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides i486 target libraries.

Package: mlton-runtime-ia64-linux-gnu
Architecture: ia64
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - ia64 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides ia64 target libraries.

Package: mlton-runtime-i486-kfreebsd-gnu
Architecture: kfreebsd-i386
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - kfreebsd-i386 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides kfreebsd i386 target libraries.

Package: mlton-runtime-x86-64-kfreebsd-gnu
Architecture: kfreebsd-amd64
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - kfreebsd-amd64 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
